﻿Module Module1
    Class FahrenheitToCelsius
        Private f_temperature As Double   'This defines a private field

        'Define the constructor
        Public Sub New(t As Double)
            Temperature = t   'This calls the setter. Property is initialized
        End Sub

        'Define a public property
        Public Property Temperature As Double
            'Define the getter
            Get
                Return 5 / 9 * (f_temperature - 32)
            End Get

            'Define the setter
            Set
                If Value >= -459.67 Then
                    f_temperature = Value
                Else
                    Throw New Exception("There is no temperature below -459.67")
                End If
            End Set
        End Property
    End Class

    'Main code starts here
    Sub Main()
        Dim x = New FahrenheitToCelsius(-68) 'This calls the constructor 
                                             'which, in turn, calls the setter

        Console.WriteLine(x.Temperature)    'This calls the getter.

        x.Temperature = -20                 'This calls the setter
        Console.WriteLine(x.Temperature)    'This calls the getter

        x.Temperature = -700                'This calls the setter and throws an error
        Console.WriteLine(x.Temperature)    'This is never executed. The flow of execution
                                            'is stopped due to the previous statement.
        Console.ReadKey()
    End Sub
End Module
