﻿Module Module1
    Class SchoolMember
        Public name As String
        Public age As Integer

        'Define the constructor
        Public Sub New(n As String, a As Integer)
            Me.name = n
            Me.age = a
            Console.WriteLine("A school member was initialized")
        End Sub
    End Class

    Class Teacher
        Inherits SchoolMember

        Public salary As Double 'This is an additional field for class Teacher 

        'Define the constructor
        Public Sub New(n As String, a As Integer, s As Double)
            MyBase.New(n, a) 'Call the constructor of the class SchoolMember

            Me.salary = s
            Console.WriteLine("A teacher was initialized")
        End Sub
    End Class

    Class Student
        Inherits SchoolMember

        Public grades(2) As Integer  'This is an additional field for class Student

        'Define the constructor
        Public Sub New(n As String, a As Integer, g() As Integer)
            MyBase.New(n, a) 'Call the constructor of the class SchoolMember

            Me.grades = g
            Console.WriteLine("A student was initialized")
        End Sub
    End Class

    'Main code starts here
    Sub Main()
        Dim teacher1 = New Teacher("Mr. John Scott", 43, 35000)
        Dim teacher2 = New Teacher("Mrs. Ann Carter", 5, 32000)

        Dim student1 = New Student("Peter Nelson", 14, {90, 95, 92})
        Dim student2 = New Student("Helen Morgan", 13, {92, 97, 94})

        Console.WriteLine(teacher1.name)
        Console.WriteLine(teacher1.age)
        Console.WriteLine(teacher1.salary)

        Console.WriteLine(student2.name)
        Console.WriteLine(student2.age)
        For Each grade In student2.grades
            Console.WriteLine(grade)
        Next
        Console.ReadKey()
    End Sub
End Module
